# generated by datamodel-codegen:
#   filename:  create_data_lab.json

from __future__ import annotations

from enum import Enum
from typing import Optional, Union

from pydantic import BaseModel, ConfigDict, Field, RootModel, conint


class EnclaveSpecification(BaseModel):
    attestationProtoBase64: str
    id: str
    workerProtocol: conint(ge=0)


class FormatType(Enum):
    STRING = 'STRING'
    INTEGER = 'INTEGER'
    FLOAT = 'FLOAT'
    EMAIL = 'EMAIL'
    DATE_ISO8601 = 'DATE_ISO8601'
    PHONE_NUMBER_E164 = 'PHONE_NUMBER_E164'
    HASH_SHA256_HEX = 'HASH_SHA256_HEX'


class HashingAlgorithm(Enum):
    SHA256_HEX = 'SHA256_HEX'


class CreateDataLabComputeV0(BaseModel):
    authenticationRootCertificatePem: str
    driverEnclaveSpecification: EnclaveSpecification
    hasDemographics: bool
    hasEmbeddings: bool
    id: str
    matchingIdFormat: FormatType
    matchingIdHashingAlgorithm: Optional[HashingAlgorithm] = None
    name: str
    numEmbeddings: conint(ge=0)
    publisherEmail: str
    pythonEnclaveSpecification: EnclaveSpecification


class CreateDataLabComputeV1(CreateDataLabComputeV0):
    pass


class CreateDataLabComputeV2(BaseModel):
    authenticationRootCertificatePem: str
    driverEnclaveSpecification: EnclaveSpecification
    hasDemographics: bool
    hasEmbeddings: bool
    hasSegments: bool
    id: str
    matchingIdFormat: FormatType
    matchingIdHashingAlgorithm: Optional[HashingAlgorithm] = None
    name: str
    numEmbeddings: conint(ge=0)
    publisherEmail: str
    pythonEnclaveSpecification: EnclaveSpecification


class CreateDataLabComputeV3(CreateDataLabComputeV2):
    pass


class CreateDataLab1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    v0: CreateDataLabComputeV0


class CreateDataLab2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    v1: CreateDataLabComputeV1


class CreateDataLab3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    v2: CreateDataLabComputeV2


class CreateDataLab4(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    v3: CreateDataLabComputeV3


class CreateDataLab(
    RootModel[Union[CreateDataLab1, CreateDataLab2, CreateDataLab3, CreateDataLab4]]
):
    root: Union[CreateDataLab1, CreateDataLab2, CreateDataLab3, CreateDataLab4] = Field(
        ...,
        description='Arguments for constructing a specific DataLab version.',
        title='CreateDataLab',
    )
